codeforces 703D Mishka and Interesting sum(数状数组维护前缀)

 

D. Mishka and Interesting sum

time limit per test

3.5 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Little Mishka enjoys programming. Since her birthday has just passed, her friends decided to present her with array of non-negative integers a1, a2, ..., an of n elements!

Mishka loved the array and she instantly decided to determine its beauty value, but she is too little and can't process large arrays. Right because of that she invited you to visit her and asked you to process m queries.

Each query is processed in the following way:

  1. Two integers l and r (1 ≤ l ≤ r ≤ n) are specified — bounds of query segment.
  2. Integers, presented in array segment [l,  r] (in sequence of integers al, al + 1, ..., areven number of times, are written down.
  3. XOR-sum of written down integers is calculated, and this value is the answer for a query. Formally, if integers written down in point 2 are x1, x2, ..., xk, then Mishka wants to know the value , where  — operator of exclusive bitwise OR.

Since only the little bears know the definition of array beauty, all you are to do is to answer each of queries presented.

Input

The first line of the input contains single integer n (1 ≤ n ≤ 1 000 000) — the number of elements in the array.

The second line of the input contains n integers a1, a2, ..., an (1 ≤ ai ≤ 109) — array elements.

The third line of the input contains single integer m (1 ≤ m ≤ 1 000 000) — the number of queries.

Each of the next m lines describes corresponding query by a pair of integers l and r (1 ≤ l ≤ r ≤ n) — the bounds of query segment.

Output

Print m non-negative integers — the answers for the queries in the order they appear in the input.

Examples

input

3
3 7 8
1
1 3

output

0

input

7
1 2 1 3 3 2 3
5
4 7
4 5
1 3
1 7
1 5

output

0
3
1
3
2

Note

In the second sample:

There is no integers in the segment of the first query, presented even number of times in the segment — the answer is 0.

In the second query there is only integer 3 is presented even number of times — the answer is 3.

In the third query only integer 1 is written down — the answer is 1.

In the fourth query all array elements are considered. Only 1 and 2 are presented there even number of times. The answer is .

In the fifth query 1 and 3 are written down. The answer is .

 

 

 

【题意】给你一个长度为n的序列,有m次查询(l,r)的区间,求区间内出现偶数个数的数的异或值。

【分析】区间偶数个数的数的异或=区间出现过的数的异或^区间奇数个数的数的异或。 因为0^1^1=0。

首先奇数个数的异或我们是很好解决的,直接打个前缀就好了。对于我们要求,区间内出现过的数的异或。刚开始只想着求出整个(1,n)区间的(数状数组维护),后来想想中间的查询是没法转移的,所以只好放弃了。其实换一个想法,就比较简单了。既然我们维护不了一个大区间的,但是我们可以维护一个(1,x)区间的。我们在加入一个数的时候,只要判断他出现过没有,尽量把他的位置放到后面就好了。

 

代码:

 

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<vector>
#include<bitset>

#define F first
#define S second
#define mp make_pair
using namespace std;
typedef __int64 LL;
const int maxn = 1e6 + 10;
const int mod = 998244353;

int h[maxn];
vector <int> v[maxn];
vector <int> sign[maxn];
map <int,int> mm;
int ans[maxn];
int pre[maxn];
int sum[maxn*4];
int last[maxn];
int lowbit(int x)
{
    return x&(-x);
}

int query(int x)
{
    if(!x) return 0;
    return sum[x]^query(x-lowbit(x));
}

void add(int x,int y,int N)
{
    while(x<=N)
    {
        sum[x]^=y;
        x+=lowbit(x);
    }
}
int main()
{
    int n,m,s,e;
    scanf("%d",&n);
    for(int i=1; i<=n; i++)
        scanf("%d",&h[i]);
    for(int i=1; i<=n; i++)
    {
        pre[i]=pre[i-1]^h[i];
    }
    scanf("%d",&m);
    for(int i=1; i<=m; i++)
    {
        scanf("%d%d",&s,&e);
        v[e].push_back(s);
        sign[e].push_back(i);
    }
    for(int i=1; i<=n; i++)
    {
        int x=mm[h[i]];
        if(x)
        {
            add(x,h[i],n);
        }
        mm[h[i]]=i;
        add(i,h[i],n);
        for(int j=0; j<v[i].size(); j++)
        {
            ans[sign[i][j]]=query(i)^query(v[i][j]-1)^(pre[i]^pre[v[i][j]-1]);
        }
    }
    for(int i=1; i<=m; i++)
        printf("%d\n",ans[i]);
    return 0;
}

 

 

 

 

 

 

 

树状数组(Fenwick Tree)是一种用于高效处理区间和查询的数据结构,常用于解一维数组前缀和、区间更新和查询等问题。 在 Codeforces 上,树状数组常被用来解决一些与区间和查询有关的问题。它可以在 O(logn) 的时间内完成单点更新和查询,以及区间求和等操作。 下面是一个简单的示例代码,展示了如何实现一个基本的树状数组: ```cpp #include <iostream> #include <vector> using namespace std; // 获取最低位的 1 int getLowbit(int x) { return x & -x; } // 树状数组的单点更新操作 void update(vector<int>& fenwick, int index, int delta) { while (index < fenwick.size()) { fenwick[index] += delta; index += getLowbit(index); } } // 树状数组前缀和查询操作 int query(vector<int>& fenwick, int index) { int sum = 0; while (index > 0) { sum += fenwick[index]; index -= getLowbit(index); } return sum; } int main() { int n; cin >> n; vector<int> fenwick(n + 1, 0); // 初始化树状数组 for (int i = 1; i <= n; i++) { int val; cin >> val; update(fenwick, i, val); } // 进行查询操作 int q; cin >> q; while (q--) { int type; cin >> type; if (type == 1) { int index, delta; cin >> index >> delta; update(fenwick, index, delta); } else if (type == 2) { int l, r; cin >> l >> r; int sum = query(fenwick, r) - query(fenwick, l - 1); cout << sum << endl; } } return 0; } ``` 在这个示例中,我们使用了一个长度为 n 的数组 `fenwick` 来表示树状数组。`update` 函数用于更新树状数组中的某个元素,`query` 函数用于查询树状数组中某个区间的和。 你可以根据具体问题的要求进行相应的修改和扩展。希望对你有所帮助!如果有任何疑问,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值